// ********************************************************************
//
//  Routine:      acReadOTR
//  Author:       T.Oest
//
//  Description:  read OTR alignment constants
//                
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include <limits.h>
#include "arte/arte.hh"
#include "database/table.h"

#include "online/esp.h"

#include "farm/farm.hh"
#include "Otr/OtrI.h"
#include "Otr/OtrEvent.h"


void TAReadFile(char* filename="/afs/desy.de/user/k/kruecker/public/align/TAAlign.txt", int prtflg=0);

static int hitprepflag = -1;


//==================================================================
// get file name, and read constants
//==================================================================

int oldalign() {

 char * OTRdb;

 if (getenv("DB_OTR_ALIGNMENT") != NULL){

   OTRdb = getenv("DB_OTR_ALIGNMENT");

   TAReadFile(OTRdb);
   return 1;
   }
 return -1;
 }

//*****************************************************************
// function
//*****************************************************************

int acReadOTR(int KTstatus) {
  if (hitprepflag==-1) {
    char *f;
    
/*                    hit preparation for OTR  */
    if ((f=getenv("OtrHitPreparation"))) hitprepflag = atoi(f);
    else hitprepflag=1;

    if ((f=getenv("OtrDqSwitch"))) OtrDqSwitch(atoi(f));
    else OtrDqSwitch(OTRDQSelectOccupOr);

    if ((f=getenv("OtrEventSwitch"))) OtrEventSwitch(atoi(f));
    
    if ((f=getenv("OtrDebugSwitch"))) OtrIDebugSwitch(atoi(f));
    else OtrIDebugSwitch(OTRIDebugDefault);//Offline); 

    OtrISwitch(OTRIUseDb|OTRIUseEnvironment); 
    OtrIInitialize();
      
    if (hitprepflag!=0) {
      if (hitprepflag==2) {
        OtrEventInfoEventGet(ARTE_get_event());
        OtrDbUpdate(OtrEventInfoDbKey());
        }
      return oldalign();
      }
    }

  if (hitprepflag==0) {
    OtrEventInfoEventGet(ARTE_get_event());
    OtrDbUpdate(OtrEventInfoDbKey());
    return 0;
    }
  else {
    return 0;
    }

  } 

