/*-- Author :    Serguei Moukhine   31/03/98 */

#include <string.h>

void chttoh_ (char *T, int *H, int *N)

/************************************************************************
**
** Description: copy C/C++ text string T (terminated by \0) into
**              Hollerith string H (type integer) containing N words.
**              The rest of H is filled with blank spaces.
**
** Called from: anywhere
**
** External references: strncpy, memset
**
** Argument in/out description
**   T      in     input string.
**   H      out    output array.
**   N      in     dimension of H
**
************************************************************************/

{
int sizeOfOut;
int nCharToCopy;
int len;

len         = strlen(T);
sizeOfOut   = *N * sizeof(int);
nCharToCopy = sizeOfOut < len ? sizeOfOut : len;
strncpy((char *)H,T,nCharToCopy);
/*
** Fill the rest of H with blank spaces.
*/
if (len < sizeOfOut)
   memset(((char *)H)+len,' ',sizeOfOut-len);

}
/************************************************************************
** End of CHTTOH
************************************************************************/
