*-- Author :    Hartwig Albrecht   26/04/95

      SUBROUTINE MMDROP (JL)

************************************************************************
*
* Description: drop table JL
*
* Called from: anywhere
*
* External references: MMDROP1
*
* Argument in/out description
*  JL      in     bank address
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/MEMS.fi"

      INTEGER I, IS, IL, JL(1), LOCF
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"

      IL = LOCF (JL) - LARLN1

C inside link area ?

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 80

C a parallel table cannot be dropped

      IF (IMEMO_FLAG(IL) .EQ. -2)  GO TO 70

C drop table JL

      CALL MMDROP1 (JL(1), IL)

C drop all subordinate tables

      DO I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
        IS = IMEMS_SUB(I)
        CALL MMDROP1 (JLINK(IS), IS)
      END DO

C take care about relations

      IF (IMEMO_FLAG(IL) .GT. 0)  CALL MMDREL (IL)

      DO I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
        IS = IMEMS_SUB(I)
        IF (IMEMO_FLAG(IS) .GT. 0)  CALL MMDREL (IS)
      END DO

      GO TO 90

 70   CALL CHHTOC (IQ(HQMEMO_NAME(1,IS)), C4)
      CALL MEERRC (765341,
     +  'MMDROP: table ' // C4 // ' not dropped (parallel table)')
      GO TO 90

 80   CALL MEERRC (47545,
     +  'MMDROP: link JL not inside ARTE link area')

 90   END

************************************************************************
* End of MMDROP
************************************************************************
