*-- Author :    Hartwig Albrecht   17/05/95

      SUBROUTINE MMWRIT (LUN, JH, IOS)

************************************************************************
*
* Description: Zebra output
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit
*   JH     in     link to a header bank
*   IOS    out    iostatus: 0 = ok; -1 = output file(s) full; never >0.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEMS.fi"
#include "auto/MEIO.fi"

      INTEGER LOCF, LUN, JH(1), I, IS, IH, IOS, ICLOSE, MMWSTAT
      CHARACTER CNAME*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"
#include "auto/MEIO.ff"

      ICLOSE = 0
      IH = LOCF(JH) - LARLN1

      IF (IH .LE. 0 .OR. IH .GT. NARLNK)  THEN
        CALL MEERRC (97655, 'MMWRIT: link JH not inside ARTE link area')
        GO TO 90
      END IF

      IF (IMEMO_SUP(1,IH) .NE. 0)  THEN
        C78 = 'MMWRIT: table'
        CALL CHHTOC (IQ(HQMEMO_NAME(1,IH)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('is not a header bank')
        CALL ME78EC (45614)
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOD(IH), 2) .EQ. 0 .OR.
     +    BITTEST (BMEMO_IOD(IH), HMEIO_BIT(LUN)) .EQ. 0)  THEN
        C78 = 'MMWRIT: header bank'
        CALL CHHTOC (IQ(HQMEMO_NAME(1,IH)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('not marked for output on')
        CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('- record skipped')
        CALL ME78PC (534888, 30)
        GO TO 90
      END IF

      IOS = MMWSTAT (LUN, IH)
C  ios = 1 -> empty table -> allowed.
      IF (IOS .GT. 1)  GO TO 90

      CALL MMOPEN (LUN, 1, IOS)
      IF (IOS .LT. 0)  GO TO 90

      CALL MMWTMM (LUN, IH, IOS)
      ICLOSE = MIN (ICLOSE, IOS)

      DO 20 I = IMEMO_SUB1(IH), IMEMO_SUB2(IH)

        IS = IMEMS_SUB(I)
        IF (IS .EQ. IH .OR. MMWSTAT (LUN, IS) .NE. 0)  GO TO 20
        CALL MMWTMM (LUN, IS, IOS)
        ICLOSE = MIN (ICLOSE, IOS)

 20   CONTINUE

      IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2) THEN
        CALL GARTENDEV (LUN)
      ENDIF
      
      IF (ICLOSE .NE. 0)  CALL IOCLOS (LUN)
      IOS = 0

 90   END

************************************************************************
* End of MMWRIT
************************************************************************
