//                              -*- Mode: C++ -*-
//: CmdCareECBoards.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 1/4/98
// Last Update ........
//

#ifndef CMDCAREECBOARDS_HH_
#define CMDCAREECBOARDS_HH_

#include "care/CmdBase.hh" 


/**
class  CmdCareECBoards.
  Class to deal with the care/ECBoards kuip command
  Define the name of the ASCII file containing the board 
  description and the ECAL coverage.
*/

class CmdCareECBoards : public CmdBase {
public:
  /// Constructor
  CmdCareECBoards();
  /// Destructor
  virtual ~CmdCareECBoards();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  ///   Read a command from external source
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();
  //--
  ///   Static access member function
  char* boardfile();

private:

  static  char filename[256];
};

#endif  //   CMDCAREBOARDS_HH_

