************************************************************************
* DGCAL0
* written by Siegmund Nowak 08/93
*
* This routines translates GEANT output hits into ZEBRA bank structures
* JHITC and JMDIGC for calorimeter
*
*       called from DGCAL
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*  IPLAT      in          Detector number in BANK JDETEC
************************************************************************

      SUBROUTINE DGCAL0(ISL)
C-----------------------------

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/HITC.fi"
#include "auto/ECHS.fi"
#include "auto/ECHF.fi"
#include "auto/ECBO.fi"

      INTEGER ISL,IPL,NMIM,IFMIMP,NDIGDE,NDIGOT,NN
      INTEGER I,IL,IX,IY,L,NDIM, ECHS, ECBO, ECALCH,  IGE
      REAL DX,DY
      INTEGER MXHIT,IWIR,IND0,IND1,IXMIMP,IDIGX,IDUMMY
      REAL XMIMP,DIGX,HTOR,DGOR
      PARAMETER (MXHIT=100)
      COMMON /WRKSP1/ IWIR(1000,4),XMIMP(8,MXHIT),DIGX(8,MXHIT),
     +                HTOR(MXHIT),DGOR(MXHIT),IND0(MXHIT),IND1(MXHIT),
     +                IDUMMY(6500)
      DIMENSION IXMIMP(8,MXHIT),IDIGX(8,MXHIT)
      EQUIVALENCE (XMIMP,IXMIMP),(DIGX,IDIGX)

      INTEGER  ADCCH, ADCCHN

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/HITC.ff"
#include "auto/ECHS.ff"
#include "auto/ECHF.ff"
#include "auto/ECBO.ff"

C*    get all HITS in detector IPL from GEANT data structure MCAL

      DO 200 I = 1, IGESL_NPL(ISL)
      IPL = IGESL_FPL(ISL) + I - 1
      NMIM = 0
      IFMIMP  = IGCAL_MIM1(IPL)
      IF(IFMIMP.NE.0) NMIM  = IGCAL_MIML(IPL) - IFMIMP + 1
      IF(NMIM.LE.0) GO TO 200

c      IF(NMIM.GT.MXHIT) THEN
c         C78 = 'DGCAL: NMIM > MAXHIT for IPL '
c         CALL CH78AI(NMIM)
c         CALL CH78AC(' for ')
c         CALL CH78AI(IPL)
c         CALL ME78EC(18282805)
c         NMIM = MXHIT
c      ENDIF


      ndim = IGCAL_NCL(IPL)
      DX = (FGCAL_XMAX(IPL) - FGCAL_XMIN(IPL))/FLOAT(NDIM)
      DY = (FGCAL_YMAX(IPL) - FGCAL_YMIN(IPL))/FLOAT(NDIM)

      NDIGOT = 0

      do ix = 1,ndim
      do iy = 1,ndim

      NDIGDE = 0

         DO 201 L=1,NMIM
         IL = IFMIMP + L - 1
         IGE = ISHFT(IMCAL_GCAL(IL),-24)
	 IF(IGE.NE.0) THEN
           IF(IGESL_CMP(IGE).NE.7) GOTO 201
         ENDIF
         IF((IMCAL_GCAL(IL)-ISHFT(IGE,24)-IPL*100).NE.(NDIM*IX+IY)) 
     +      GO TO 201
         ECHS = ECALCH(IMCAL_GCAL(IL), ECBO)
*          Skip unconnected channels
	 IF( ECHS.NE.0 ) THEN
	   IF( ECBO.LE.0 ) GOTO 201
           IF( IECBO_STAT(ECBO).LE.0) THEN
 	    GOTO 201
           ENDIF
	 ENDIF

         IF(NDIGDE.EQ.0) THEN
            CALL MMBOOK(JHITC,1)
            NN = NHITC()
C            IQ(IQHITC_GCAL_L()) = IMCAL_GCAL(IL)
	    IQ(IQHITC_GCCE_L()) = ECHS
            Q (QHITC_X_L()) = FGCAL_XMIN(IPL) + (IX-.5)*DX
            Q (QHITC_Y_L()) = FGCAL_YMIN(IPL) + (IY-.5)*DY
            IF(NDIGOT.EQ.0) IQ(IQGCAL_HIT1(IPL)) = NN
            Q (QHITC_Q_L()) = FMCAL_DE(IL)
	    Q (QHITC_ADC_L()) = 0.0
         ELSE
            Q (QHITC_Q_L() ) = FMCAL_DE(IL) + Q (QHITC_Q_L())
         ENDIF

         CALL MMBREL(JMCHC,IL,NN)
         NDIGDE = NDIGDE + 1
         NDIGOT = NDIGOT + 1
  201    CONTINUE

      ENDDO
      ENDDO
      IQ(IQGCAL_HITL(IPL)) = NN
 200  CONTINUE

 999  RETURN
      END

