
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
// changes:
// 07 Sep 1999 (AG) add processing time histo
// 09 Sep 1999 (AG) polishing
// 04 Oct 1999 (AG) polishing
// 07 Oct 1999 (AG) decrease range for processing time
// 21 Oct 1999 (AG) polishing
// 27 Oct 1999 (AG) use defines from DQ.h
// 29 Oct 1999 (AG) redefine histogram IDs
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 22 Feb 2000 (AG) change scale of time
// 05 Apr 2000 (AG) change booking of times
// 12 May 2000 (AG) change booking of processing time from 10 to 20
// 15 May 2000 (AG) corrected binning
// 17 May 2000 (AG) sizes of some raw tables
// 22 May 2000 (AG) change scale of 4LT_node histogram
// 24 May 2000 (AG) histogram bytes
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_hit_init()
{
  cout << "DQ_FARM_hit_init()" << endl;
  
  // book histograms
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 1 ), "FARM: Trigger code", 16, -0.5, 15.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 2 ), "FARM: Target Rate [MHz]", 50, 0, 50. );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 3 ), "FARM: SLP_node", 240, -0.5, 239.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 4 ), "FARM: 4LT_node", 110, -0.5, 109.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 5 ), "FARM: RECO Time [sec]", 100, 0.0, 20.0 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 6 ), "FARM: Raw event size [kB]", 40, 0.0, 200.0 );
  //rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 7 ), "FARM: Time difference [sec]", 40, -10000., 10000. );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 15 ), "FARM: DQ Time [sec]", 100, 0.0, 1.0 );

  // size of some raw tables
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 101 ), "FARM: DSVD [B]", 100, 0, 20000 ); // B
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 102 ), "FARM: DITR [B]", 100, 0, 50000 ); // B
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 104 ), "FARM: DOTR [B]", 100, 0, 50000 ); // B

  return 0;
}
