
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// Filling of histograms
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
//         histogram id: 1 - 65535
//
// changes:
// 27 Oct 1999 (AG) use defines in DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

// float faDTARia();
// int faDDAQFCS_tcode();

//
// function code
//
int DQ_MUON_hit_evnt()
{
  //  float NrMUONHits=0;
  //  float NrMUONTubeHits=0;
  //  float NrMUONPadHits=0;
  //  float NrMUONPixelHits=0;
  float NrMUONHitsMt1=0;
  float NrMUONHitsMt2=0;
  float NrMUONHitsMt3=0;
  float NrMUONHitsMt4=0;
  float NrMUONHitsMp3=0;
  float NrMUONHitsMp4=0;
  float NrMUONHitsMx1=0;
  float NrMUONHitsMx2=0;
  float NrMUONHitsMx3=0;
  float NrMUONHitsMx4=0;

  //  float ia = faDTARia();              // Interaction rate
  //  int tcode = faDDAQFCS_tcode();      // Trigger code
  //  ArtePointer<EVHD> evhd(1);
  //  int runno = evhd->run;              // run number


  for (ArteTableIterator<HITB> hitb; hitb.valid(); hitb.next() ) {

    ArtePointer<GEDE> gede(hitb->gede); 

    if (gede->cmp==8) { // tube and pad chambers
         
      if (strncmp(gede->gesl->name,"MUD1",4)==0) {  // MU1 tube chambers
	NrMUONHitsMt1++;
	//  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf001),gede.index(),1);
              
	if (gede->symx>200) { // upper part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1011),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1013),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1015),hitb->x,1);}
	} else { // lower part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1012),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1014),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1016),hitb->x,1);}
	}
      }

      if (strncmp(gede->gesl->name,"MUD2",4)==0) {  // MU2 tube chambers
	NrMUONHitsMt2++;
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf002),gede.index(),1);

	if (gede->symx>200) { // upper part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1021),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1023),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1025),hitb->x,1);}

	} else { // lower part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1022),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1024),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1026),hitb->x,1);}
	}
      }

      if (strncmp(gede->gesl->name,"MUD3",4)==0){ 
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf003),gede.index(),1);
 
	if (fabs(hitb->y)<0.000001) { // tube, no pad
	  NrMUONHitsMt3++;

	  if (gede->symx>200) {// upper part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1031),hitb->x,1);
	  } else { // lower part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1032),hitb->x,1);
	  }

	} else { // pad
	  NrMUONHitsMp3++;
	  rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x2003),hitb->x, hitb->y,1);
	}
      }

      if (strncmp(gede->gesl->name,"MUD4",4)==0){ 
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf004),gede.index(),1);
	if (fabs(hitb->y)<0.000001) { // tube, no pad
	  NrMUONHitsMt4++;

	  if (gede->symx>200) { // upper part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1041),hitb->x,1);
	  } else { // lower part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1042),hitb->x,1);
	  }
	} else { // pad
	  NrMUONHitsMp4++;
	  rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x2004),hitb->x, hitb->y,1);
	}
      }

    }     //  End of Pad and Tube Loop

    if (gede->cmp==9) { // pixel chambers

      //  if (strncmp(gede->gesl->name,"MXD",3)==0)
      //  {
      //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf030),
      //  gede.index()-gede->gesl->fpl + 6*(gede->gesl.index()-35),1);
      //  }

      if (strncmp(gede->gesl->name,"MXD1",4)==0) { // MU1 pixel
	NrMUONHitsMx1++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x3001),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD2",4)==0) { // MU2 pixel
	NrMUONHitsMx2++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x3002),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD3",4)==0) { // MU3 pixel
	NrMUONHitsMx3++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x3003),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD4",4)==0) { // MU4 pixel
	NrMUONHitsMx4++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x3004),hitb->x, hitb->y,1);
      }

    }    //  End of Pixel Loop

  }      //  End of HitB Loop

  
  //  NrMUONTubeHits = NrMUONHitsMt1 + NrMUONHitsMt2 + NrMUONHitsMt3 + NrMUONHitsMt4;
  //  NrMUONPadHits = NrMUONHitsMp3 + NrMUONHitsMp4;
  //  NrMUONPixelHits = NrMUONHitsMx1 + NrMUONHitsMx2 + NrMUONHitsMx3 + NrMUONHitsMx4;
  //  NrMUONHits = NrMUONTubeHits + NrMUONPadHits + NrMUONPixelHits;


  //=========================================
  //    Hits per Event Histograms
  //=========================================

  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa001),NrMUONHitsMt1,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa002),NrMUONHitsMt2,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa003),NrMUONHitsMt3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa004),NrMUONHitsMt4,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xb003),NrMUONHitsMp3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xb004),NrMUONHitsMp4,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc001),NrMUONHitsMx1,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc002),NrMUONHitsMx2,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc003),NrMUONHitsMx3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc004),NrMUONHitsMx4,1);

  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd001),NrMUONHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd002),NrMUONTubeHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd003),NrMUONPadHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd004),NrMUONPixelHits,1);


  //==========================================
  //    Occupancy vs BX Histogtrams
  //==========================================
  //  ArtePointer<DIHD>dihd(1);
  //  int physBX = dihd->bx;              // Physical BX Number

  // rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1),physBX,NrMUONHitsMt1);
  // rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1),221.,1.);              // for normalization

  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x1),physBX,NrMUONHitsMt1);
  


  return 0; // return error code (0 = okay)
}
