
#ifndef _EVTCLASS_H
#define _EVTCLASS_H

// *****************************************************************************
//
// source:    evtclass.h
//
// type:      header file
//
// created:   08 May 2000
//    
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// purpose:   define event classification bits (1-32)
//
// changes:
// 09 May 2000 (AG) introduce class JPSIEE and JPSIMM
// 23 May 2000 (AG) introduce class RNDTRG
// 25 May 2000 (AG) introduce class FLTTRG
// 29 May 2000 (AG) introduce single high-ET ECAL trigger
//
// *****************************************************************************

// physical classes (so far)
#define ECLASS_JPSIEE  0x1         // bit= 1 J/Psi -> e+ e-
#define ECLASS_JPSIMM  0x2         // bit= 2 J/Psi -> mu+ mu-
#define ECLASS_CAL1HT  0x400       // bit=11 single high-ET ECAL cluster trigger
#define ECLASS_RNDTRG  0x40000000  // bit=31 random trigger (FCS_tcode=8 || 9)
#define ECLASS_FLTTRG  0x80000000  // bit=32 FLT trigger (FCS_tcode=0 || 8)

// examples
#define ECLASS_1  0x1
#define ECLASS_2  0x2
#define ECLASS_3  0x4
#define ECLASS_4  0x8
#define ECLASS_5  0x10
#define ECLASS_6  0x20
#define ECLASS_7  0x40
#define ECLASS_8  0x80
#define ECLASS_9  0x100
#define ECLASS_10 0x200
#define ECLASS_11 0x400
#define ECLASS_12 0x800
#define ECLASS_13 0x1000
#define ECLASS_14 0x2000
#define ECLASS_15 0x4000
#define ECLASS_16 0x8000
#define ECLASS_17 0x10000
#define ECLASS_18 0x20000
#define ECLASS_19 0x40000
#define ECLASS_20 0x80000
#define ECLASS_21 0x100000
#define ECLASS_22 0x200000
#define ECLASS_23 0x400000
#define ECLASS_24 0x800000
#define ECLASS_25 0x1000000
#define ECLASS_26 0x2000000
#define ECLASS_27 0x4000000
#define ECLASS_28 0x8000000
#define ECLASS_29 0x10000000
#define ECLASS_30 0x20000000
#define ECLASS_31 0x40000000
#define ECLASS_32 0x80000000

#endif
