/************************************************************************
* GRADLN
* written by Siegmund Nowak, 30/12/94 10.45.29
*
* This routine calculates the radiation length XMS for a material with
* volumen number IVO
*
*       called from geometry routines
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* IVOL       in           Geant volumen number
* XMS        out          Radiation length
************************************************************************/
#include <string.h>
#include "arte/arte.hh"
#include "gean/gclink.h"

extern "C" {

  void gradln_(const int &ivo, float &xms) {
    int jvo = *(gcbank_.lq + gclink_.jvolum -1 - ivo);
    int *pji = gcbank_.iq + jvo+3;
    float *pjx = (float *)pji; 
    int numed = int(*pjx);
    int jmd = *(gcbank_.lq + gclink_.jtmed -1 - numed);
    pji = gcbank_.iq + jmd + 5;
    pjx = (float *)pji; 
    int nmat = int(*pjx);
    int jmt = *(gcbank_.lq + gclink_.jmate -1 - nmat);
    memcpy(&xms,gcbank_.iq + jmt +8,4);
  }
}


