#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "gean/hgdat.h"
#include "arte/ArteMessage.hh"
//#define DEBUG
// ------------------------------------------------------------------------
  
  
int ricscan(int*);

  typedef struct {
    int   bufsize;
    int   ib;
    char  ricbuf[8000];
    } CommonRicBuf;
     
  typedef struct {
    int   trkfl;
    int   color;
    int   seen;
    int   superlayer;
    char  mother[8];
    char  name  [8];
    char  shape [8];
    char  material[24];
    } CommonRicVol;

  typedef struct {
    float x0,y0,z0;
    int   irot;
    float the1,phi1,the2,phi2,the3,phi3;
    int   npar;
    float par[100];
    char  only[8];
    } CommonRicPos;
    
  typedef struct {
    int   npckov;
    float e[200];
    float a[200];
    float n[200];
    float eff[200];
    float polish;
    } CommonRicMat;
    
// ------------------------------------------------------------------------  

extern "C" {
  void rtst_();
  int ricscan_(int *flag) { return ricscan(flag); }
  
  extern CommonRicBuf cricbuf_;
  extern CommonRicPos cricpos_;
  extern CommonRicVol cricvol_;
  extern CommonRicMat cricmat_;
  }
  
CommonRicBuf cricbuf;
  
  
// ------------------------------------------------------------------------  

void getdirname(char *name,char *fname) {
  strcpy(fname,name);
  }
  
// ------------------------------------------------------------------------  
  
int ricscan(int* flag) {
  CommonRicBuf& buf=cricbuf_;
  CommonRicPos& pos=cricpos_;
  CommonRicVol& vol=cricvol_;
  CommonRicMat& mat=cricmat_;
//  
//
//  
  
  int  ib   =buf.ib;
  char *card=&buf.ricbuf[ib];
  
  char   tag[80];  // FFREAD is length limited
  
  double econv=1,lconv=1;
  
#ifdef DEBUG
    printf("entry\n",tag);
#endif

  int tagid=0;
  for(;;) {
    buf.ib=card-buf.ricbuf;
    int nitem=sscanf(card,"%s",tag);
    if (nitem!=1) return tagid;   
    ToLower(tag);

#ifdef DEBUG
    printf("%d %s\n",nitem,tag);getchar();
#endif
    

    if (!strcmp(tag,"volume:")) {
      if (tagid) return tagid;
      *flag=tagid=1;
      
//
// default values  
//
      vol.seen=0;
      vol.superlayer=0;

      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s %s %s %s %d ",
        vol.mother,vol.name,vol.shape,vol.material,&vol.trkfl);
      if (nitem!=5) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      
      fillstr(vol.mother,4);
      fillstr(vol.name  ,4);
      fillstr(vol.shape ,4);
      fillstr(vol.material,20);

//      buf.ib=card-buf.ricbuf;
//      return tagid;
      }  
    else if (!strcmp(tag,"positioning_of...:")) {
      if (tagid) return tagid;
      *flag=tagid=2;
      
//
// default values  
//
      pos.irot=0;
      strcpy(pos.only,"ONLY   ");
      
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s",vol.name);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      fillstr(vol.name  ,4);
      }
    else if (!strcmp(tag,"color..........:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d",&vol.color);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      vol.seen=1;
      }
    else if (!strcmp(tag,"superlayer.....:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s",tag);
      if (nitem!=1){arteMsg << "ricscan " << tag; arteMsg.error();} 
      card+=itemlength(card,nitem);
      ToLower(tag);
      if (!strcmp(tag,"yes")) vol.superlayer=1;
      }
    else if (!strcmp(tag,"origin.........:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f %f %f",&pos.x0,&pos.y0,&pos.z0);
      if (nitem!=3) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      }
    else if (!strcmp(tag,"rotation.......:")) {
      pos.irot=1;

      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s %f %f %s %f %f %s %f %f",tag,&pos.the1,&pos.phi1
                                  ,tag,&pos.the2,&pos.phi2,
                                   tag,&pos.the3,&pos.phi3);
      if (nitem!=9) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);        
      }
    else if (!strcmp(tag,"only-flag......:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s",pos.only);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      fillstr(pos.only  ,4);
      }
    else if (!strcmp(tag,"parameter......:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d",&pos.npar);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      int i;
      for (i=0;i<pos.npar;i++) {
        nitem=sscanf(card,"%f",&pos.par[i]);
        if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
        card+=itemlength(card,nitem);        
        }
      }
      
    else if (!strcmp(tag,"metall:")) {
      if (tagid) return tagid;
      *flag=tagid=3;
    
      mat.n[0]=0;  // is a metall
      mat.a[0]=0;  // is a metall
      
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s %d",vol.material,&vol.trkfl);
      if (nitem!=2) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      fillstr(vol.material,20);
      }
    else if (!strcmp(tag,"dielectric:")) {
      if (tagid) return tagid;
      *flag=tagid=4;
    
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s %d",vol.material,&vol.trkfl);
      if (nitem!=2) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);
      fillstr(vol.material,20);
      }
   else if (!strcmp(tag,"polish:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%f",&mat.polish);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem);    
      }
    else if (!strcmp(tag,"units:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%s",tag);
      if (nitem!=1){arteMsg << "ricscan " << tag; arteMsg.error();} 
      card+=itemlength(card,nitem);    
      if (!strcmp(tag,"nm")) econv=-10E-9*197.327;
      if (!strcmp(tag,"eV")) econv=10E-9;
      if (!strcmp(tag,"GeV"))econv=1;
      if (tagid!=3) {
        nitem=sscanf(card,"%s",tag);
        if (nitem!=1) continue;
        card+=itemlength(card,nitem);    
        if (!strcmp(tag,"m"))  lconv=1E2;
        if (!strcmp(tag,"cm")) lconv=1;
        if (!strcmp(tag,"mm")) lconv=1E-1;
        }
      }
    else if (!strcmp(tag,"table:")) {
      card+=itemlength(card,nitem);
      nitem=sscanf(card,"%d",&mat.npckov);
      if (nitem!=1) {arteMsg << "ricscan " << tag; arteMsg.error();}
      card+=itemlength(card,nitem); 
      
      if (tagid==3) {
        int i;
        if (econv>0) {
          for (i=0;i<mat.npckov;i++) {
            nitem=sscanf(card,"%f %f",&mat.e[i],&mat.a[i]);
            if (nitem!=2) {arteMsg << "ricscan " << tag; arteMsg.error();}
            card+=itemlength(card,nitem);   
            mat.e[i]*=econv;
            mat.eff[i]=1.0; // no photon generation
            } 
          }
        else { // if wavelength is given
          for (i=mat.npckov-1;i>=0;i--) {
            nitem=sscanf(card,"%f %f",&mat.e[i],&mat.a[i]);
            if (nitem!=2) {arteMsg << "ricscan " << tag; arteMsg.error();}
            card+=itemlength(card,nitem);   
            mat.e[i]=-econv/mat.e[i];
            mat.eff[i]=1.0; // no photon generation
            } 
          }
        }
      else if (tagid==4) { 
        int i;
        if (econv>0) {
          for (i=0;i<mat.npckov;i++) {
            nitem=sscanf(card,"%f %f %f %f",
              &mat.e[i],&mat.a[i],&mat.n[i],&mat.eff[i]);
            if (nitem!=4) {arteMsg << "ricscan " << tag; arteMsg.error();}
            card+=itemlength(card,nitem);   
            mat.e[i]*=econv;
            mat.a[i]*=lconv;
            } 
          }
        else { // if wavelength is given
          for (i=mat.npckov-1;i>=0;i--) {
            nitem=sscanf(card,"%f %f %f %f",
              &mat.e[i],&mat.a[i],&mat.n[i],&mat.eff[i]);
            if (nitem!=4) {arteMsg << "ricscan " << tag; arteMsg.error();}
            card+=itemlength(card,nitem);   
            mat.e[i]=-econv/mat.e[i];
            mat.eff[i]=1.0; // no photon generation
            } 
          }
        }  
      }
    else  
        {arteMsg << "ricscan:  tag not found " << tag ; arteMsg.error();}
  }
  }

