#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteUtil.h"
#include "arte/ArteMessage.hh"
#include "gean/gclink.h"
#include "gean/zgeom.h"

extern "C" {void crrotm_(int*,float*,float*,float*,float*,float*,float*);  }

vector<hgrot> *zgrot::ptrot[33];

void zgrot::ini(int n){ 
  ptrot[ind_pt] = new vector<hgrot>;
        if(ptrot[ind_pt]==NULL) {
          arteMsg << "no hgrot[n] allocated";
          arteMsg.error();      
        }
        ptrot[ind_pt]->reserve(n);

        hgrot HGROT;
        HGROT.irotm = 0; 
        HGROT.rotnum = 0; 
        HGROT.grot[0] = HGROT.grot[4] = HGROT.grot[8] = 1.;
        HGROT.arot[0] = HGROT.arot[4] = HGROT.arot[8] = 1.;
        HGROT.grot[1] = HGROT.grot[2] = HGROT.grot[3] = HGROT.grot[5] = 
        HGROT.grot[6] = HGROT.grot[7] = HGROT.arot[1] = HGROT.arot[2] =
        HGROT.arot[3] = HGROT.arot[5] = HGROT.arot[6] = HGROT.arot[7] = 0.; 
        ptrot[ind_pt]->push_back(HGROT);
}

void zgrot::fin() {   
        delete ptrot[ind_pt];
}

int  zgrot::Readrot(char *card,int &nr) {
        hgrot HGROT;
        int nitem=sscanf(card,"%d %f %f %f %f %f %f",&HGROT.rotnum,
                         &HGROT.theta1, &HGROT.phi1,   &HGROT.theta2,
                         &HGROT.phi2,   &HGROT.theta3, &HGROT.phi3); 
        if (nitem!=7)   {
            arteMsg <<"check data on rotation cards";    arteMsg.error();
        } 
        if (HGROT.rotnum ==0 )  {
            arteMsg <<"Rotnum 0 is reserved for no rotation"; arteMsg.error();
        } 
        ptrot[ind_pt]->push_back(HGROT);
        nr = ptrot[ind_pt]->size();
        return HGROT.rotnum; }
 

int  zgrot::Create_Grot(int &nr) {
        vector<hgrot>::iterator rot = ptrot[ind_pt]->begin() + nr -1;
        crrotm_(&rot->irotm,&rot->theta1,&rot->phi1,&rot->theta2,
                                 &rot->phi2, &rot->theta3, &rot->phi3);
        int jrot= gclink_.jrotm;
        jrot = *(gcbank_.lq + gclink_.jrotm -1 -rot->irotm);
        memcpy(rot->grot,gcbank_.iq + jrot,36);

        rot->arot[0] = rot->grot[0];
        rot->arot[1] = rot->grot[3];
        rot->arot[2] = rot->grot[6];
        rot->arot[3] = rot->grot[1];
        rot->arot[4] = rot->grot[4];
        rot->arot[5] = rot->grot[7];
        rot->arot[6] = rot->grot[2];
        rot->arot[7] = rot->grot[5];
        rot->arot[8] = rot->grot[8];
        return rot->irotm;
}

int  zgrot::Checkxy_Grot(const float g[], float &angle) {
        angle =0.;
        if(g[8] < .99999) return 0;
        if(g[0]>.99999 && g[4]>.99999 ) return 1;
        if(fabs(g[0]) > .9999) {
            angle=float(acos(g[0])*AR_RADDEG); return 1;
        } 
        else if(fabs(g[1]) > .9999)  {
	  angle=float(asin(g[1])*AR_RADDEG);  return 1;
        }
        return 0;
}

void  zgrot::Arot_par(float &xmin,float &xmax,float &ymin,float &ymax,
                                                           float gr[]) { 
        float par[2], mean[2];
        mean[0]=.5*( (xmin + xmax)* gr[0] + (ymin + ymax)* gr[1]);  
        mean[1]=.5*( (xmin + xmax)* gr[3] + (ymin + ymax)* gr[4]);
        par[0]=fabs(.5*(gr[0]*(xmax-xmin) + gr[1]*(ymax-ymin))); 
        par[1]=fabs(.5*(gr[1]*(xmax-xmin) + gr[0]*(ymax-ymin))); 
        xmin = mean[0] - par[0];    xmax = mean[0] + par[0];
        ymin = mean[1] - par[1];    ymax = mean[1] + par[1];  }

void  zgrot::Set_UnitMatrix(float gr[]) {
        gr[0] = gr[4] = gr[8] = 1.;
	gr[1] = gr[2] = gr[3] = gr[5] = gr[6] = gr[7] = 0.;}
               











