*-- Author :    Thomas Lohse   June 10, 1999

      SUBROUTINE KALEPT

************************************************************************
*
* Description: LEPTON command
*              allows to require one or two leptons with pt cuts
*              and invariant mass cut
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/luopts.fi"

      INTEGER i
      integer message_id_1

      save message_id_1

      call KUGETI(nlept)
      if (nlept.ne.1 .and. nlept.ne.2) then
        nlept = 0
          call MEERRC (message_id_1, 
     +          'LEPTON: Invalid number of trigger leptons')
      endif
      call KUGETR(ptl1)
      if (ptl1.lt.0.)  ptl1=0.
      if (nlept.eq.1) then
        ptl1    = ptl1**2
      elseif (nlept.eq.2) then
        call KUGETR(ptl2)
        if (ptl2.lt.0.)  ptl2=0.
        if (ptl1.ge.ptl2) then
          ptl1  = ptl1**2
          ptl2  = ptl2**2
        else
          xml12 = ptl1**2
          ptl1  = ptl2**2
          ptl2  = xml12
        endif
        call KUGETR(xml12)
        if (xml12.lt.0.) xml12=0.
        xml12 = xml12**2
      endif

 90   END

************************************************************************
* End of KALEPT
************************************************************************
