*CMZ :  1.00/01 03/02/95  18.42.47  by  Alexander Snizhko
*CMZ :  0.01/02 11/09/94  11.49.57  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   27/07/94
************************************************************************
*
* L1DETIF
* written by Dominik Ressing, 27/07/94 17.11.26
*
* This routines action:
* returns pointers to description of specified detector part
* or 0,0,0 on invalid detector specifiers.
* ATTENTION: ZEBRA pointers ay become invalid !!!
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iDetSpe     in          detector specifier as defined in $l1detdf
* iGeoInf     out         Pointer to Geometry description of detector
* iDetInf     out         Pointer to detector information
* iCellGeo    out         Pointer to Geometry description
*
************************************************************************
c
      SUBROUTINE L1DETIF(iDetSpe,iGeoInf,iDetInf,iCellGeo)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
c
      INTEGER iDetSpe(L1DETSPElen),l1detsl,
     &        iGeoInf,iDetInf,iCellGeo
      INTEGER isl,lay,isec,  ! superlayer,layr,sector of detector
     &        JDET,nlay,nsec
      INTEGER itype          ! detector type
      INTEGER nword,LcellStep
c
c
      isl = iDetSpe(L1DETSPEdet)           ! sequential detector number
      IF (isl.GT.l1nDetUsed) 		THEN ! wrong idet
         GOTO 777
      ELSE
         JDET = LQ(L1JDET-isl)  ! pointer to SL begining
         nlay = IQ(JDET+L1GEOINFlen+L1DETINFnlay)
         nsec = IQ(JDET+L1GEOINFlen+L1DETINFnsec)
         lay = iDetSpe(L1DETSPElayer) ! layer within superlayer
         isec = iDetSpe(L1DETSPEsection) ! sector number of detector
         IF (lay.GT.nlay.OR.isec.GT.nsec) THEN ! wrong lay or isec
            GOTO 777
         ELSE

            itype=IQ(JDET+L1GEOINFlen+L1DETINFhbtype)

            IF(itype.eq.L1DETtypeMU) then      ! muon detector information
             nword=2*L1GEOINFlen+L1DETINFlenMu ! looks slightly different
             LCellStep=L1DETINFlenMu
            ELSE
             nword=2*L1GEOINFlen+L1DETINFlen
             LCellStep=L1DETINFlen
            ENDIF

            JDET = JDET+((isec-1)*nlay+(lay-1))*nword

            iGeoInf = JDET
            JDET = JDET + L1GEOINFlen
            iDetInf = JDET
            JDET = JDET+LCellStep
            iCellGeo = JDET
         ENDIF
      ENDIF
c
      RETURN
c
 777  CONTINUE
c     --- error exit
      iGeoInf  = 0
      iDetInf  = 0
      iCellGeo = 0
      WRITE(L1LUNprn,910) iDetSpe(L1DETSPEdet),
     &                    iDetSpe(L1DETSPElayer),
     &                    iDetSpe(L1DETSPEsection),isl
 910  FORMAT(1x,
     & 'L1DETIF ==> invalid detector iseq-det/layer/section/isl:'/
     & 10x,4i7)
c
      RETURN
c
      END



