*CMZ :          04/09/96  21.03.11  by  Fedor Ratnikov
*CMZ :  1.00/00 22/12/94  19.31.31  by  Dominik Ressing
*-- Author :    Dominik Ressing   10/12/94
************************************************************************
*
* L1GETRS
* written by Dominik Ressing, 10/12/94 14.40.10
*
* This routines action:
* Find tracks for points and return weather the track has hit all projections
* in iFlags: 4 for zero hit
*            2 for +alpha hit
*            1 for -alpha hit
* i.e. 6 fo zero and +alpha hit ....
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iHiPosZ     in       Hit pointer for the found hits 0 layer
* iHiPosP     in       Hit pointer for the found hits + alpha layer
* iHiPosN     in       Hit pointer for the found hits - alpha layer
* N           update   Dimension of itrs(*) on input; # of found tracks on output
* itrs(N)     out      first completly covered track
* iFlags(N)   out      Hits for this track in the 3 projections
*
************************************************************************
c
      SUBROUTINE L1GETRS(iHiPosZ,iHiPosP,iHiPosN,N,itrs,iFlags)
c
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rcfdef.fi"
c
      INTEGER iHiPosZ,iHiPosP,iHiPosN,itrs(*),iFlags(*),N
      REAL    z,P,x,y,Pa
c
      INTEGER ila,imask,i,k,nfou,jAux,
     &        iMax,itr
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
c
      Nfou = 0
c
      iMax = N_U(JL1_MESS)
c
      DO ila=1,3
         IF ( ila.eq.1 ) THEN
            IF ( iHiPosZ.ge.1 .and. iHiPosZ.le.iMax ) THEN
               jAux = I_1(iHiPosZ,JL1_ME_MTRA)
            ELSE
               jAux = 0
            END IF
            imask = 4
         ELSE IF ( ila.eq.2 ) THEN
            IF ( iHiPosP.ne.0 .and. iHiPosP.le.iMax ) THEN
               jAux = I_1(iHiPosP,JL1_ME_MTRA)
            ELSE
               jAux = 0
            END IF
            imask = 2
         ELSE IF ( ila.eq.3 ) THEN
            IF ( iHiPosN.ne.0 .and. iHiPosN.le.iMax ) THEN
               jAux = I_1(iHiPosN,JL1_ME_MTRA)
            ELSE
               jAux = 0
            END IF
            imask = 1
         END IF
         DO WHILE ( jAux.gt.0 ) ! relation pointer valid ??
            itr  = K_1(jAux,JL1_ME_MTRA)
            jAux = N_1(jAux,JL1_ME_MTRA)
c
            DO k=1,Nfou
               IF ( itrs(k).eq.itr ) THEN
                  iflags(k) = IOR(imask,iflags(k))
                  GO TO 333
               END IF
            END DO
            IF ( Nfou.eq.N ) GO TO 444
            Nfou = Nfou + 1
            itrs(  Nfou) = itr
            iflags(Nfou) = imask
c
 333        CONTINUE
         END DO
      END DO
c
      GO TO 555
c
 444  CONTINUE
      WRITE (L1LUNprn,*) 'L1GETRS ==> to many tracks',Nfou,N
c
 555  CONTINUE
c
      N = Nfou
c
      RETURN
c
      END
