*CMZ :          04/09/96  20.29.04  by  Fedor Ratnikov
*CMZ :  1.00/05 22/09/95  18.52.22  by  Fedor Ratnikov
*CMZ :  1.00/01 23/03/95  14.19.15  by  Alexander Snizhko
*CMZ :  0.01/03 18/09/94  22.44.04  by  Fedor Ratnikov
*CMZ :  0.01/02 13/09/94  00.40.38  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   27/07/94
************************************************************************
*
* L1HIGET
* written by Dominik Ressing, 27/07/94 17.18.03
*
* This routines action:
* Returns pointers to Hit storage for set Hits (else 0) -1 is a test hit
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iPrc        in          Pointer to processor to search hits for
* iSec        in          Number of connected detector
* iLay        in          Layer number in detector
* iBX         in          bunch crossing number of hits
* iFirst      in          first considered Hit number
* nHit        in          length of expected hit string
* iHits(,*)   out         string of Hit-pointers on return (minimal
*                         dimension of array iHits is nHit)
*
************************************************************************
c
      SUBROUTINE L1HIGET(iPrc,iSec,iLay,iBX,iFirst,nHit,iHits)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1detuse.fi"
#include "l1si/rcfdef.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1banks.fi"
#include "l1si/l1prcdf.fi"
#include "arte/Arte.fi"
c
      INTEGER iPrc,iSec,iLay,iBX,iFirst,nHit,iHits(L1HITlen,*)
c
      INTEGER iLast,jRow,nRow,iPoC,iPoV,iPoR,jBase(1),iRel,iTab,
     &        iTFU,i,N,
     &        jAux,iType,j,kRow,kRel,iDet,Num
      INTEGER iCopy
      REAL    rCopy
      EQUIVALENCE (iCopy,rCopy)
      INTEGER LOCF
      EXTERNAL LOCF
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
c
      CALL VZERO(iHits,nHit*L1HITlen)
c
      iType = L1PCstor(iPrc+L1PCtype)
      IF ( iType.eq.L1PCttfu ) THEN
         iTFU = L1PCstor(iPrc+L1PCnum)          ! get TFU num
         iTab = LOCF(JL1HI_T)-LOCF(jBase)+1     ! pointer to table
         jRow = L1HI_T_PO(iBX,iTFU,iSec,iLay)   ! first entry for this TFU/CON/LAY
         nRow = L1HI_T_NN(iBX,iTFU,iSec,iLay)   ! number of entries for ...
         iPoC = L1HI_T_CELL                     ! position of cell id in column of table
         iPoV = L1HI_T_CELL                     ! dummy
         iPoR = L1HI_T_REL                      ! position of relation in column ...
         iRel = LOCF(JL1HI_T_MTRA)-LOCF(jBase)+1! pointer to relations table
      ELSE IF ( iType.eq.L1PCtpre ) THEN

         Num=L1PCstor(iPrc+L1PCnum)


         IF ( L1DEFpredef(L1PREkind,num).eq.L1PREelec ) THEN

         iTab = LOCF(JL1HI_E)-LOCF(jBase)+1     ! pointer to table
         jRow = L1HI_E_PO(iBX,iSec)             ! first entry for this ECAL module
         nRow = L1HI_E_NN(iBX,iSec)             ! number of entries for this ECAL module
         iPoC = L1HI_E_CELL                     ! position of cell id in column of table
         iPoV = L1HI_E_E                        ! position of amplitude in column ...
         iPoR = L1HI_E_REL                      ! position of relation in column ...
         iRel = LOCF(JL1HI_E_MTRA)-LOCF(jBase)+1! pointer to relations table

      ELSE IF ( L1DEFpredef(L1PREkind,num).eq.L1PREmuon.or
     $        .L1DEFpredef(L1PREkind,num).eq.L1PREpxmuon ) THEN
            iDet=iLay                           ! for muon pretrigger
                                                ! iLay means detector name
         iTab = LOCF(JL1HI_MU)-LOCF(jBase)+1     ! pointer to table
         jRow = L1HI_MU_PO(iBX,iDet,iSec)       ! first entry for this muon section
         nRow = L1HI_MU_NN(iBX,iDet,iSec)       ! number of entries for this muon section
         iPoC = L1HI_MU_PAD                     ! position of cell id in column of table
         iPoR = L1HI_MU_REL                     ! position of relation in column ...
         iRel = LOCF(JL1HI_MU_MTRA)-LOCF(jBase)+1! pointer to relations table

      ELSE IF ( L1DEFpredef(L1PREkind,num).eq.L1PREpipi ) THEN
c P.Pakhlov Pretrigger for B--> pi+pi- study    ! I.B.
         iTab = LOCF(JL1HI_P)-LOCF(jBase)+1     ! pointer to table
          jRow =  L1HI_P_PO(iBX,iLay,iSec) ! first entry for this P.Pakhlov Chamber
          nRow =  L1HI_P_NN(iBX,iLay,iSec) ! number of entries for this P.Pakhlov Chamber
          iPoC =  L1HI_P_CELL                   ! position of cell id in column of table
          iPoV =  L1HI_P_CELL                   ! dummy
          iPoR =  L1HI_P_REL                    ! position of relation in column ...
         iRel = LOCF(JL1HI_P_MTRA)-LOCF(jBase)+1! pointer to relations table

         ENDIF
      ELSE
         WRITE (L1LUNprn,*)
     &        'L1HIGET ==> invalid PRC',iPrc,iType
         RETURN
      END IF
c
      iLast = iFirst + nHit -1
      kRow  = jRow + nRow - 1
c
      DO i=jRow,kRow                                ! scan table
         N = I_V(iPoC,i,Jbase(iTab))                       ! Cell ID of table entry (column)
c
         IF (N.ge.iFirst .and. N.le.iLast ) THEN    ! of intrest ??
c
            j = N-iFirst+1                            ! cell position in
                                                      ! iHits
            iHits(L1HITnpo,j) = iHits(L1HITnpo,j) + 1 ! hit found !
            iCopy = iHits(L1HITvalue,j)
            rCopy = rCopy+F_V(iPoV,i,JBase(iTab)) ! accumulate amplitude
            iHits(L1HITvalue,j) = iCopy
c
c           --- maintain relations:
c
            kRel = iHits(L1HITpos,j)       ! relation row number assigned to hit j
            IF (kRel.eq.0) THEN            ! is it valid ?
               kRel = N_U(JL1_MESS) + 1        ! number of used rows in table
               IF ( kRel.ge.N_F(JL1_MESS) )
     &              CALL UTETAB(IXDIV,JL1_MESS,100) ! expand table
               iHits(L1HITpos,j) = kRel        ! store relation row number
               IQ(JL1_MESS+2) = kRel           ! write number of used rows
            END IF
c
            CALL L1CPREL(IXDIV,1,  ! copy relations with MC track
     &           JBase(iRel),i,JL1_ME_MTRA,kRel)
         END IF
      END DO
c
      RETURN
c
      END

