
#ifndef MuNesl_h
#define MuNesl_h 1

//## Class: MuNesl
//      /**Author:        Boris Fominykh
//
//      Date:             December 21, 1999
//
//      Class:            MuNesl
//
//      Base Class:       none
//
//      Description:
//      This is a container class for muon NESL elements
//      key word neslkey = 10*msl+cmp (msl=1-4, cmp = 8 or 9)
//      key word nedekey = 10000*msl+1000*lay+100*updown+10*nx+sd
//      the regions are  msl    1-4
//                       lay    1-3
//                       updown 0-1
//                       nx     1-99
//                       sd     0-1  */

class MuNesl
{
public:
    //## Constructor
      MuNesl();
    //## Destructor
      ~MuNesl();

// public methods
    //        /**Initialization*/
      void Ini();
    //        /**Print*/
      void Print();

// public variables

      int Valid;
      int neslkey;
      int inesl;
      int cmp;
      int shp;
      int nsl;
      int mfl;
      int lay;
      float x1;
      float x2;
      float y1;
      float y2;
      float z1;
      float z2;
      float dx;
      float dy;
      int npl;
      int fpl;
      int nwl;
      int fwl;
      int ltyp;
      int pnsl;
      char name[5];
      int chamb[6];
      int nx99[6];
 
  protected:
  private:
};
#endif
