*
* B.Fominykh  22.07.97
* routine managing the tree grouth from one seed
*
* input: ISTAR  - start branch containing the seed
*        IDEBPR - debug print control, =0 - no print
*
      SUBROUTINE MURBRGR(ISTAR,IDEBPR)
C     ================================
      IMPLICIT NONE
#include "murec/MUCPAR.fi"
#include "murec/MUCTAB.fi"
#include "murec/MUCZDT.fi"
#include "murec/MUCKALF.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
      INTEGER IRL,IBR,JBR,IBRMX,NBRCR,I,J,IHT,JHT,IHT1,IHT2
      INTEGER IHTR,IOUT,IBRU,JW,ISTAR,IDEBPR,JNBR
      REAL ZR,ZRR,ERMSC1,ERMSC2,THETS,XREX,YREX,SINR,COSR
      REAL SIGX,SIGY,CHIX,CHIY,DSD,YSD,SMS,SIGS,CHIP,DD,SIGEXT
      REAL CHI,CHI1,CHI2,CHIM
      DOUBLE PRECISION PARMM(5),COVM(4,4)
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
* loops over reconstruction layers
      ZR=-1.
      DO 300 IRL=18,1,-1
        IF(NMUACL(IRL).LT.1) GOTO 300      ! no active clusters - nothing to do
* Z for preselection
        IF(ZR.GT.0.) THEN
          ZRR=ZR
        ELSE
          ZRR=0.5*(ZMUDT1(IRL)+ZMUDT2(IRL))
        ENDIF
        ZR=0.5*(ZMUDT1(IRL)+ZMUDT2(IRL))
* loops over branchs
        IBRMX=IFREE-1
        DO 200 IBR=ISTAR,IBRMX
          NBRCR=0
          JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* is the branch dead?
          IF(IQ(JBR+1).EQ.0) GOTO 200
* extrapolation of seed to ZR
          XREX=Q(JBR+8)*(ZR-Q(JBR+5))+Q(JBR+6)
          YREX=Q(JBR+9)*(ZR-Q(JBR+5))+Q(JBR+7)
          DO I=1,5
            PARAM(I)=Q(JBR+I+4)
            PARMM(I)=PARAM(I)
          ENDDO
          DO I=1,4
            DO J=1,4
              COV(I,J)=Q(JBR+4*I+J+5)
              COVM(I,J)=COV(I,J)
            ENDDO
          ENDDO
          CHIM=Q(JBR+4)
* multiple scattering
          CALL MURMSC(ZRR,ZR,ERMSC1,ERMSC2,THETS)
*
      IF(IDEBPR.GT.0)
     + WRITE(LLOGF,1001) IRL,IBR,ZRR,ZR,ERMSC1,ERMSC2
 1001 FORMAT(1X,'RL,BR',2I3,' Z1,Z2',2F7.1,' ERms1,2',2F6.2)
*
          IHT1=JCLPT1(IRL)
          IHT2=JCLPT1(IRL)+NMUCLL(IRL)-1
          DO 100 IHT=IHT1,IHT2
            JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
* not use the killed clusters
            IF(IQ(JHT+1).EQ.0) GOTO 100
* hit type
            IHTR=IQ(JHT+5)
* preselection in the case of wire
            IF(IHTR.NE.1) GOTO 50
            SINR=Q(JHT+7)
            COSR=SQRT(1.-SINR*SINR)
            DSD=XREX*COSR-YREX*SINR
            YSD=XREX*SINR+YREX*COSR
            SMS=Q(JHT+11)**2
            SIGS=ERMSC1*ERMSC1+SMS+SGEX2
            CHIP=(Q(JHT+8)-DSD)**2/SIGS
*
      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1401) IRL,IBR,IHT,SIGS,CHIP
 1401 FORMAT(1X,'IRL,IBR,ICL,SIGS,CHIP',3I5,2E12.4)
      WRITE(LLOGF,1402) YSD,Q(JHT+9)-DYSURE,Q(JHT+10)+DYSURE
 1402 FORMAT(10X,' YSD,YCUT1,YCUT2',3E12.4)
      ENDIF
*
* 1st check-point
            IF(CHIP.GT.CCUTR) GOTO 100
* 2nd check-point
            IF(YSD.LT.Q(JHT+9)-DYSURE)  GOTO 100
            IF(YSD.GT.Q(JHT+10)+DYSURE) GOTO 100

* Kalman filtering in the case of wire
            DO I=1,5
             PARAM(I)=PARMM(I)
            ENDDO
            DO I=1,4
             DO J=1,4
              COV(I,J)=COVM(I,J)
             ENDDO
            ENDDO
            SIGMS1=ERMSC1
            SIGMS2=ERMSC2
            ZMEAS=Q(JHT+6)
            SINROT=SINR
            COSROT=SQRT(1.-SINROT*SINROT)
            DMEAS=Q(JHT+8)
            SMEAS=Q(JHT+11)
            ITMEAS=1
            IF(Q(JHT+7).NE.0.) ITMEAS=3
            CALL MURKALF(0,IOUT,DD,SIGEXT,CHI)

      IF(IDEBPR.GT.0)
     + WRITE(LLOGF,*) 'cl,dd,chi,IOUT',IHT,DD,CHI,IOUT

            IF(IOUT.NE.0) GOTO 100
            GOTO 70
*
* preselection in the case of pads and pixels
  50        CONTINUE
            IF(IHTR.NE.2.AND.IHTR.NE.3) GOTO 100
            SMS= Q(JHT+11)**2
            SIGX=ERMSC1*ERMSC1+SMS+SGEX2
            CHIX=(Q(JHT+8)-XREX)**2/SIGX
            SMS= Q(JHT+12)**2
            SIGY=ERMSC1*ERMSC1+SMS+SGEX2
            CHIY=(Q(JHT+9)-YREX)**2/SIGY

      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1501) IRL,IBR,IHT,SIGX,CHIX,SIGY,CHIY
 1501 FORMAT(1X,'IRL,IBR,IHT',3I5,
     +         ' SIGX,CHIX,SIGY,CHIY',4E12.4)
      ENDIF

* check-points
            IF(CHIX.GT.CCUTR) GOTO 100
            IF(CHIY.GT.CCUTR) GOTO 100
* Kalman filtering in the case of pad or pixel
            DO I=1,5
             PARAM(I)=PARMM(I)
            ENDDO
            DO I=1,4
             DO J=1,4
              COV(I,J)=COVM(I,J)
             ENDDO
            ENDDO
            SIGMS1=ERMSC1
            SIGMS2=ERMSC2
            ZMEAS=Q(JHT+6)
            SINROT=0.
            COSROT=1.
            DMEAS=Q(JHT+8)
            SMEAS=Q(JHT+11)
            ITMEAS=1
            CALL MURKALF(0,IOUT,DD,SIGEXT,CHI1)
            IF(IOUT.NE.0) GOTO 100
*
            DMEAS=Q(JHT+9)
            SMEAS=Q(JHT+12)
            ITMEAS=2
            CALL MURKALF(0,IOUT,DD,SIGEXT,CHI2)
            IF(IOUT.NE.0) GOTO 100
            CHI=CHI1+CHI2
*
* hit was linked
  70        CONTINUE
            NBRCR=NBRCR+1
*
            IF(IDEBPR.GT.0) WRITE(LLOGF,*) 
     +      'accepted cl,RL,BR,BRcr',IHT,IRL,IBR,NBRCR
*
            IBRU=IBR
* create new branch ?
            IF(NBRCR.EQ.1) GOTO 90
            IF(IFREE+1.GT.NBMUTR) GOTO 200
            CALL MMBOOK(JTMP7,1)
            JBR =JTMP7+IQ(JTMP7+1)*(IBR-1)+2
            JNBR=JTMP7+IQ(JTMP7+1)*(IFREE-1)+2
            IBRU=IFREE
            IFREE=IFREE+1
            IQ(JNBR+1)=1
             Q(JNBR+2)=0.
            IQ(JNBR+3)=IQ(JBR+3)-1
             Q(JNBR+4)=CHIM
            DO I=1,IQ(JNBR+3)
              IQ(JNBR+LCMUTR+I)=IQ(JBR+LCMUTR+I)
            ENDDO

      IF(IDEBPR.GT.0) WRITE(LLOGF,1012)
     +         ISTAR,IRL,IBR,IQ(JTMP7+2),IFREE
 1012 FORMAT(1X,'new branch created, ISTAR,IRL,IBR,NB,IFREE:',5I5)

* update the branch
  90        CONTINUE
            JBR =JTMP7+IQ(JTMP7+1)*(IBRU-1)+2
* update parameters and covariance
            DO I=1,5
             Q(JBR+I+4)=PARAM(I)
            ENDDO
            DO I=1,4
             DO J=1,4
              Q(JBR+4*I+J+5)=COV(I,J)
             ENDDO
            ENDDO
* pointer to cluster
            IQ(JBR+3)=IQ(JBR+3)+1  ! +1 cluster to counter
            JW=JBR+LCMUTR+IQ(JBR+3)
            IQ(JW) =IHT
            Q(JBR+4)=Q(JBR+4)+CHI ! sum chi**2

      IF(IDEBPR.GT.0) WRITE(LLOGF,1014) IBRU,IHT,DD,CHI
 1014 FORMAT(1X,'branch',I3,' updated with clust',I3,' DD,CHI',2E12.4)

*
  100     CONTINUE
*
  200   CONTINUE
*
  300 CONTINUE
*
  999 CONTINUE
      RETURN
      END






