*-- Author :    Rainer Mankel   16/12/95

      subroutine pkhit(pl,idmc,chopt)

*     **** draw all hits in plane pl
*     **** if hit.ne.0, draw only hit "hit"
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"

      character*(*) chopt
      real xxx(21), yyy(21), wcw1(3), wcw2(3), sintot, costot,
     +     xxxw(5), yyyw(5)
      integer pl, idmc, imc, hit, hit1, hit2
      integer ih, cmp, isl, tumchit
      integer xsig(4), ysig(4)
      real d_pro, d_trunc, dx, dy, s, rseg
      parameter (hit=0)
      logical lb0, trmcor, ltop, lside

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
      data xsig /-1, +1, +1, -1/, ysig /-1, -1, +1, +1/

      lb0     = lb0zg .or. index(chopt,'B').gt.0
      isl = ogede_gesl(pl)
      cmp = igesl_cmp(isl)

      if (isl.le.0) print *,' () dihit: pl,isl=',pl,isl
C
      IF(cmp.EQ.6) GO TO 51
C

      if (cmp.gt.4.and.cmp.le.7) then
         go to 999              ! unsupported plane type
      endif

      sintot = fgede_sin(pl) * fgede_rot(1,pl) ! total coordinate angle
     +     + fgede_cos(pl) * fgede_rot(2,pl)

      costot = fgede_cos(pl) * fgede_rot(1,pl)
     +     - fgede_sin(pl) * fgede_rot(2,pl)

      if (.not.lstereozg) then
*        **** bypass stereo planes
         if (cmp.ne.1) then
            if (abs(sintot).gt.0.001) go to 999
         endif
      endif

*     **** decide kind of view
      ltop = (abs(sintot).lt.0.01.and.iviewzg.eq.1)
     +     .or. (sintot.gt.0.01.and.iviewzg.eq.7)
     +     .or. (sintot.lt.-0.01.and.iviewzg.eq.8)

      lside = (.not.ltop) .and.
     +     iviewzg.eq.0 .or. (iviewzg.ge.3 .and. iviewzg.le.6)
C
      GO TO 52
C
 51   CONTINUE
C
      ltop = (iviewzg.eq.1)
     +     .or. (iviewzg.eq.7)
     +     .or. (iviewzg.eq.8)

      lside = (.not.ltop) .and.
     +     iviewzg.eq.0 .or. (iviewzg.ge.3 .and. iviewzg.le.6)
C
 52   CONTINUE
C
      if (hit.eq.0) then
         if (igede_hit1(pl).gt.0) then
            hit1 = igede_hit1(pl)
            hit2 = igede_hitl(pl)
         else
            hit1 = 0
            hit2 = -1
         endif
      else
         hit1 = hit
         hit2 = hit
      endif

*     **** loop over hits
      do 10 ih=hit1,hit2
         if (ih.eq.0) go to 11

*        **** check associated MC particle
         if (idmc.ne.0) then
*        **** discard if no match with MC particle
            if (.not.trmcor(ih,idmc)) go to 10
         endif

         if (lb0) then          ! check B0 option
            imc = tumchit(ih)
            if (.not.gold_mh(imc)) go to 10
         endif

         if (lwirezg.or.index(chopt,'W').gt.0) then ! check wire option

            call igsg(1)

            if (cmp.ne.9.and.cmp.ne.4.and.
     +           (cmp.ne.8.or.fhitb_y(ih).eq.0.))  then ! wire-like

               IF(cmp.NE.6) then
                call digetw(ih,wcw1(1),wcw2(1)) ! get wire endpoints
               ELSE
                call digett(ih,wcw1(1),wcw2(1))
               END IF

               call dipro(wcw1(1),xxxw(1),yyyw(1))
               call dipro(wcw2(1),xxxw(2),yyyw(2))


               if (ltop) then   ! view is along channel
                  rseg = (xpickzg-xxxw(1))**2 + (ypickzg-yyyw(1))**2
               elseif (lside) then
                  dx = xpickzg - 0.5*(xxxw(1)+xxxw(2))
                  dy = ypickzg - 0.5*(yyyw(1)+yyyw(2))
                  s = (xxxw(2)-xxxw(1))**2 + (yyyw(2)-yyyw(1))**2
                  d_pro = ( dx * (xxxw(2)-xxxw(1))
     +                    + dy * (yyyw(2)-yyyw(1)))**2 / s
                  d_trunc = amax1(d_pro - 0.25 * s,0.)
                  rseg = dx**2 + dy**2 - d_pro + d_trunc
               endif
            else                ! pixel-like detector
               wcw1(1) = fhitb_x(ih)
               wcw1(2) = fhitb_y(ih)
               wcw1(3) = fhitb_z(ih)
               call dipro(wcw1,xxx(1),yyy(1))
               rseg = (xpickzg-xxx(1))**2 + (ypickzg-yyy(1))**2
            endif

         endif

         if (rseg.lt.rpickzg) then
            idpickzg = ih
            rpickzg = rseg
         endif

 10   continue
 11   continue

 999  end


