*-- Author :    Rainer Mankel   23/09/95

      subroutine dmlay97()

*     **** set up domain layers
      implicit none

#include "rang/zdomain.fi"
#include "rang/zdomdir.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
      integer max_neigh
      parameter (max_neigh=4)
      integer sl, pl, sector, method, ngsector, ngpl, ii, domain, neigh,
     +        window, layer, dlayer, last_dlayer(2:3), twin
      real umin, umax, x_min, x_max
      integer neigh_sect(max_neigh,max_sector_dm)
      data neigh_sect /
     +    1, 5, 0, 0,
     +    2, 5, 0, 0,
     +    3, 6, 0, 0,
     +    4, 6, 0, 0,
     +    5, 1, 2, 0,
     +    6, 1, 2, 0,
     +    7, 0, 0, 0,
     +    8, 0, 0, 0,
     +    9, 0, 0, 0,
     +   10, 2, 6,12,
     +   11, 7, 8, 0,
     +   12, 9,10, 0,
     +   13,14,20, 0,
     +   14, 3,13, 0,
     +   15,16,18, 0,
     +   16, 4,15, 0,
     +   17, 6,18, 0,
     +   18,15,17, 0,
     +   19, 5,20, 0,
     +   20,13,19, 0,
     +   21, 0, 0, 0,
     +   22, 0, 0, 0,
     +   23, 0, 0, 0,
     +   24, 0, 0, 0,
     +   25, 0, 0, 0,
     +   26, 0, 0, 0,
     +   27, 0, 0, 0,
     +   28, 0, 0, 0,
     +   29, 0, 0, 0,
     +   30, 0, 0, 0,
     +   31, 0, 0, 0,
     +   32, 0, 0, 0/

      save neigh_sect

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      n_dl = 0                  ! reset domain layer table
      n_dp = 0                  ! reset layer plane table

      do ii=1,maxgede_dg        ! clear gede translation table
       dlayer_dg(ii) = 0
      enddo

      do window=1,n_dw          ! loop over domain windows
       domain = domain_dw(window)
       if (plshad_dw(window).gt.0) then
        sl = ogede_gesl(plshad_dw(window))
        sector = secshad_dw(window)
       else
        print *,' () dmlay97: zero plshad for window=', window
        go to 999
       endif
       do ii=1,3                ! reset layer pointers
        nlayer_dw(ii,window) = 0
        layer1_dw(ii,window) = 0
       enddo



       method = 1
       do layer=1,max_layer_dm  ! loop over layers
        pl = plane_matrix_dm(layer,method,sector,sl) ! look up plane
        if (pl.gt.0) then
*        **** accept domain layer
         if (n_dl.lt.maxlay_dl) then
          n_dl = n_dl + 1
         else
          print *,' () dmlay97: overflowing n_dl=', n_dl
          go to 999
         endif
         if (pl.le.maxpl_dp) then
          dlayer_dg(pl) = n_dl
         else
          print *,' () dmlay97: cannot mark pl=', pl
         endif
         nlayer_dw(method,window) = nlayer_dw(method,window) + 1
         if (nlayer_dw(method,window).eq.1) then
          layer1_dw(method,window) = n_dl
          prvlay_dl(method,n_dl) = 0
         else
          nxtlay_dl(method,n_dl-1) = n_dl
          prvlay_dl(method,n_dl) = n_dl - 1
         endif
         layerlst_dw(method,window) = n_dl
         laydom_dl(n_dl) = domain
         win_dl(n_dl)    = window
         wlayer_dl(n_dl) = layer
         do ii=1,3
          nxtlay_dl(ii,n_dl) = 0
         enddo
         z_dl(n_dl) = 0.5 * (fgede_zmin(pl) + fgede_zmax(pl))

*        **** locate layer planes
         nlayplane_dl(n_dl) = 0
         do 20 neigh=1,max_neigh
          ngsector = neigh_sect(neigh,sector)
          if (ngsector.eq.0) go to 20
          ngpl = plane_matrix_dm(layer,method,ngsector,sl)
          if (ngpl.eq.0) go to 20
          call tfxrang(ngpl,x_min,x_max)
          if (x_min.gt.xmax_dw(window).or.x_max.lt.xmin_dw(window))
     +                                    go to 20 ! check x range
          if (n_dp.lt.maxpl_dp) then
           n_dp = n_dp + 1
          else
           print *,' () dmlay97: overflowing n_dp=', n_dp
           go to 999
          endif
          nlayplane_dl(n_dl) = nlayplane_dl(n_dl) + 1
          if (nlayplane_dl(n_dl).eq.1) layplane1_dl(n_dl) = n_dp
          domlay_dp(n_dp) = n_dl
          gede_dp(n_dp) = ngpl
          call tfuwind(ngpl,xmin_dw(window),xmax_dw(window),
     +                 ymin_dw(window),ymax_dw(window),umin,umax)
          if (umax.lt.umin) print *,' () dmlay97: umin, umax=',
     +                                          umin, umax
          umin_dp(n_dp) = umin - 2. ! 2cm tolerance
          umax_dp(n_dp) = umax + 2. !

*         **** look for twin planes (96 run)
          twin = twin_dg(ngpl)
          if (twin.le.0) go to 20
          call tfxrang(twin,x_min,x_max)
          if (x_min.gt.xmax_dw(window).or.x_max.lt.xmin_dw(window))
     +                                    go to 20 ! check x range
          if (n_dp.lt.maxpl_dp) then
           n_dp = n_dp + 1
          else
           print *,' () dmlay97: overflowing n_dp=', n_dp
           go to 999
          endif
          nlayplane_dl(n_dl) = nlayplane_dl(n_dl) + 1
          if (nlayplane_dl(n_dl).eq.1) layplane1_dl(n_dl) = n_dp
          domlay_dp(n_dp) = n_dl
          gede_dp(n_dp) = twin
          call tfuwind(twin,xmin_dw(window),xmax_dw(window),
     +                 ymin_dw(window),ymax_dw(window),umin,umax)
          if (umax.lt.umin) print *,' () dmlay97: umin, umax=',
     +                                          umin, umax
          umin_dp(n_dp) = umin - 2. ! 2cm tolerance
          umax_dp(n_dp) = umax + 2. !









 20      continue
        endif ! pl
       enddo ! layer

       if (scope_dm(domain).eq.3) then  ! set up pointers for zero/st
        do method=2,3
         last_dlayer(method) = 0
         do layer=1,max_layer_dm  ! loop over layers
          pl = plane_matrix_dm(layer,method,sector,sl) ! look up plane
          if (pl.gt.0) then
           dlayer = dlayer_dg(pl) ! get domain layer associated prevly
           if (dlayer.le.0.or.dlayer.gt.n_dl) then
            print *,' () dmlay97: invalid pl, dlayer=', pl, dlayer
            go to 999
           endif
           if (last_dlayer(method).eq.0) then
            layer1_dw(method,window) = dlayer
            prvlay_dl(method,dlayer) = 0
            nlayer_dw(method,window) = 1
           else
            nxtlay_dl(method,last_dlayer(method)) = dlayer
            prvlay_dl(method,dlayer) = last_dlayer(method)
            nlayer_dw(method,window) = nlayer_dw(method,window) + 1
           endif
           layerlst_dw(method,window) = dlayer
           last_dlayer(method) = dlayer
          endif
         enddo
         if (last_dlayer(method).ne.0)
     +                    nxtlay_dl(method,last_dlayer(method)) = 0
        enddo ! method
       endif ! scope

      enddo ! window
      print *,' dmlay97: # domain layers created=', n_dl
      print *,' dmlay97: # domain layer planes created=', n_dp
 999  end

