*CMZ :          25/09/96  14.03.51  by  T. Oest
*-- Author :    T. Oest   28/05/96

      SUBROUTINE RKNEWH(H, DELTA, PREC, OK, HNEW)

************************************************************************
*
* Description: calculates a new step size
*
* Called from:
*
* External references:
*
* Argument in/out description
* H        in     old step size
* DELTA(4) in     estimated error
* PREC(4)  in     required precision
* OK       out    =.TRUE. if precision was met
* HNEW     out    new step size
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      DOUBLE PRECISION H, HNEW, DELTA(4), PREC(4)
      DOUBLE PRECISION RATIO(4)
      INTEGER          IMIN, I
      DOUBLE PRECISION SAFE
      LOGICAL          OK

#include "arte/Arte.ff"

      DATA SAFE /0.95D0/
************************************************************************
* compare error with precision
************************************************************************
      IMIN = 1
      DO I=1,4
       IF (DELTA(I) .NE. 0.0) THEN
        RATIO(I) = ABS(H*PREC(I)/DELTA(I))
       ELSE
        RATIO(I) = 10000.D0
       ENDIF
       IF (I.GE.2 .AND. RATIO(I).LT.RATIO(IMIN)) IMIN = I
      ENDDO


      HNEW = H * SAFE * RATIO(IMIN)**0.25
c      print*,' rknewh ',h,hnew

      IF (RATIO(IMIN) .GE. 1.D0 ) THEN
       OK   = .TRUE.
      ELSE
       OK   = .FALSE.
      ENDIF


      END

************************************************************************
* End of RKNEWH
************************************************************************
