*-- Author :    Rainer Mankel   22/05/96

      subroutine tfpropyn(direction)
*     **** vertical track-follow all alive seeds in /zf/
*     **** (between begin_ft and nca_ft)
      implicit none
#include "arte/Arte.fi"
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax), n_target, tumchit
      integer ift, izf, ipl, icycle, method, ncan, ii,
     +        zone, iplnext, imust, izfnew, nhl, nhlmx, ihl, iii,
     +        domlay,dw,dlnext,direction
      real u, y, tfxint, dz, y_pred, dy_window

      real xmin,xmax,ymin,ymax
      integer rgdlwin,rgnavig
      real rgzlay

      parameter (nhlmx=100)
      integer hl(nhlmx), nca_now, to_be_grown
      logical continued

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

**      print *,' this is tfpropy...'
**      call rgxprodmp()

*     **** loop over growth cycles
      do 10 icycle=1,99

*      **** loop over present number of track candidates
       nca_now = nca_ft
       to_be_grown = 0
       do 20 ift=begin_ft,nca_now
        if (.not.alive_ft(ift)) go to 20
        if (mature_ft(ift))     go to 20
        to_be_grown = to_be_grown + 1

        if (diag_level.ge.4) then
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
         print *,' << track candidate ', ift, '                    <<'
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
        endif

*       **** loop over planes in zone
        izf = last_ft(ift)
        ipl = plane_zf(izf)
        domlay = domlay_zf(izf)
        zone = fault_zf(izf) + 1
        ncan = 0
        continued = .false.
        method = 3  ! y tracking
        if (diag_level.ge.4) then
         print *,' tfpropy: call tfdzone2 for domlay=', domlay,
     +           '  zone=', zone,' direction ', direction
        endif

        n_target = 0
        call rgzone(domlay,method-1,zone,direction,3,3,1,nmax,
     +       target_vec,n_target)
**        print *,' tfpropy: rgzone returns n_target=',n_target

        if (diag_level.ge.5) then
         print *,' tfpropy: domlay,method,zone,n_target,target_vec=',
     +                     domlay,method,zone,n_target,
     +                     (target_vec(iii),iii=1,n_target)
        endif
        do 30 ii=1,n_target
           dlnext = target_vec(ii)

*          **** check if navigable
           if (rgnavig(rgdlwin(dlnext)).ne.1) go to 30

*          **** check if window is intersected
           dz = rgzlay(dlnext) -  z_zf(izf)
           y_pred = xx_zf(2,izf) + xx_zf(4,izf) * dz
           dy_window = 20.0
           call rgdlwbord(dlnext,xmin,xmax,ymin,ymax)
           if (y_pred.lt.(ymin-dy_window).or.
     +          y_pred.gt.(ymax+dy_window)) go to 30

*          **** can/must plane found
           ncan = ncan + 1

*          **** loop over hits
           nhl = 0
**           print *,' tfpropy: call rghlcr'
           if (rgdlwin(dlnext).ne.rgdlwin(domlay)) then
              call rghlcr(dlnext,2,dble(z_zf(izf)),
     +             xx_zf(1,izf),xx_zf(2,izf),xx_zf(3,izf),xx_zf(4,izf),
     +             nhlmx,hl,nhl)
**            print *,' tfpropy: rghlcr returns nhl=',nhl
           else
              call rghlcrpr(dlnext,2,dble(z_zf(izf)),
     +             xx_zf(1,izf),xx_zf(2,izf),xx_zf(3,izf),xx_zf(4,izf),
     +             nhlmx,hl,nhl)
           endif

           do 40 ihl=1,nhl
              if (diag_level.ge.5) then
                 print *,' tfpropy: hitlist ihl=',ihl,' hit=',
     +                hl(nhl),' imc=', tumchit(hl(nhl))
              endif
              iplnext = ihitb_gede(hl(nhl))
**              print *,' tfpropy: call tffily'
              call tffilyn(hl(ihl),dlnext,iplnext,ift,izf,izfnew)
**              print *,' tfpropy: tffily done'
              if (izfnew.gt.0) continued = .true.
 40        continue


 30     continue

*       **** allow fault on old candidate
        if (fault_zf(izf).lt.maxflt_paty_zfpar) then
           fault_zf(izf) = fault_zf(izf) + 1
           nfault_ft(ift) = nfault_ft(ift) + 1
           if (l_diag) then
              if (diag_level.ge.5) then
                 print *,' tfpropy: new fault ',fault_zf(izf),
     +                ' on ift=',ift
              endif
           endif
        else
*          **** kill or freeze old candidate
           if (l_diag) then
              if (diag_level.ge.5) then
                 print *,' tfpropy: terminate ',
     +                'maxflt=',maxflt_paty_zfpar,' ift=',ift
              endif
           endif
           if (nhit_zf(izf).lt.nhitmin_y_zfpar) then
              alive_ft(ift) = .false.
              if (l_diag) then
                 if (diag_level.ge.5) then
                    print *,' tfpropy: kill for nhit_zf=',nhit_zf(izf)
                 endif
              endif
           else
              mature_ft(ift) = .true.
              stat_ft(ift) = 2
           endif
        endif
**        if (diag_level.ge.5) call tfl()

 20    continue
       call tfweey()
       if (l_diag) then
          if (diag_level.ge.4) then
             print *,' **********************************************'
             print *,' *                                            *'
             print *,' *                                            *'
             print *,' *           E  N  D     O  F                 *'
             print *,' *                                            *'
             print *,' *           G  R  O  W  T  H                 *'
             print *,' *                                            *'
             print *,' *            C  Y  C  L  E                   *'
             print *,' *                                            *'
             print *,' *                                            *'
             print *,' **********************************************'
             call tfl()
          endif
          call tfwait()
       endif

       if (to_be_grown.le.0) go to 11

 10   continue
      print *,' () tfpropy: loop ends ii=99'

 11   if (diag_level.ge.4) then
       call tfl()
       print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

      end
