*-- Author :         Ruediger Mahn  17-Nov-97

*  updated for rotations and cylindrical wires  
*  R. Mankel 4-Jul-99

************************************************************
      SUBROUTINE RC99AVTWIR(iw)
*                                                          *
* Action :  Fill Wire Buffer of Vertex Package             *
*                                                          *
* Input :  iw  number of wire in table GTAR                *
*                    
*
* Modification:
*  -- modification for 99 data             6/09/99 T.Oest
*  -- set target constraints to 2,0.5 cm  29/10/99 T.oest
*
*                                      
************************************************************

*** Variable declaration
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GTAR.fi"

#include "vt/vtwire.fi"

      INTEGER  iw

      DOUBLE PRECISION  dwtar,lwtar,theta,phi


*** Declaration of statement functions

#include "arte/Arte.ff"
#include "auto/GTAR.ff"

*** a-priori rotation direction
      if (igtar_shap(iw).eq.1) then
         if (abs(fgtar_dx(iw)).ge.abs(fgtar_dy(iw))) then
            theta = atan2(fgtar_rot(7,iw),fgtar_rot(9,iw))
            phi   = atan2(-fgtar_rot(2,iw),fgtar_rot(5,iw))
            dwtar = abs(fgtar_dy(iw))
            lwtar = abs(fgtar_rot(7,iw) * fgtar_dx(iw))
     +            + abs(fgtar_rot(8,iw) * fgtar_dy(iw))
     +            + abs(fgtar_rot(9,iw) * fgtar_dz(iw))

         else
            theta = atan2(fgtar_rot(8,iw),fgtar_rot(9,iw))
            phi   = atan2(-fgtar_rot(1,iw),fgtar_rot(4,iw))
            dwtar = abs(fgtar_dx(iw))
            lwtar = abs(fgtar_rot(7,iw) * fgtar_dx(iw))
     +            + abs(fgtar_rot(8,iw) * fgtar_dy(iw))
     +            + abs(fgtar_rot(9,iw) * fgtar_dz(iw))
         endif
      elseif (igtar_shap(iw).eq.5) then
         theta = atan2(fgtar_rot(9,iw),fgtar_rot(7,iw))
         phi   = atan2(-fgtar_rot(2,iw),fgtar_rot(5,iw))
         dwtar = abs(fgtar_dx(iw))
         lwtar = abs(fgtar_rot(7,iw) * fgtar_dx(iw))
     +        + abs(fgtar_rot(8,iw) * fgtar_dx(iw))
     +        + abs(fgtar_rot(9,iw) * fgtar_dz(iw))
      else
c         print *,' () vtwir: shap=',igtar_shap(iw),' not defined'
         theta = 0
         phi = 0
         dwtar = 0.
         lwtar = 0.
      endif
        
* Wire center position and rotation angles
      xw(1,nw) = fgtar_rot(1,iw) * fgtar_x(iw)
     +         + fgtar_rot(2,iw) * fgtar_y(iw)
     +         + fgtar_rot(3,iw) * fgtar_z(iw)
      xw(2,nw) = fgtar_rot(4,iw) * fgtar_x(iw)
     +         + fgtar_rot(5,iw) * fgtar_y(iw)
     +         + fgtar_rot(6,iw) * fgtar_z(iw)
      xw(3,nw) = fgtar_rot(7,iw) * fgtar_x(iw)
     +         + fgtar_rot(8,iw) * fgtar_y(iw)
     +         + fgtar_rot(9,iw) * fgtar_z(iw)
      THEW(nw) = theta
      PHIW(nw) = phi


* RMS Width and length of wire (in beam direction)
*      SIGTW(nw) = 10. * dwtar/sqrt(12.)
*      SIGLW(nw) = lwtar/sqrt(12.)
      SIGTW(nw) = 0.5
      SIGLW(nw) = 2.0

c      print*,' position ',xw(1,nw),xw(2,nw),xw(3,nw)
c      print*,' theta, phi ',THEW(nw), PHIW(nw)
c      print*,' sigmat,l ',SIGTW(nw), SIGLW(nw)

      RETURN
      END

************************************************************
* End of VTWIRE                                            *
************************************************************
