/* perform loop on RSEG table, choose matched segments and fill RTRA bank */

#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"

#include "reco/Rc99Matches.hh"


int rc99MarpleRtra()
{
  Rc99MatchVector matches;
  

  for(ArteTable<RSEG>::iterator irseg = ArteTable<RSEG>::begin();
      irseg !=ArteTable<RSEG>::end(); ++irseg )
    {
      if( (*irseg)->fit != 7 ) continue;  // choose RSEG from marple
      ArtePointer<RSEG> match(*irseg);

      //==========================================================
      // SVD - RICH 
      //==========================================================
      if( match->cmp & Rsegc::vxd &&
	  match->cmp & Rsegc::rich ) 
	matches.addSvdRich(match);
      else if ( match->cmp & Rsegc::ecal &&
		match->cmp & Rsegc::rich )
	matches.addRichEcal(match);
      else if ( match->cmp & Rsegc::vxd && 
		match->cmp & Rsegc::ecal )
	matches.addSvdEcal(match);
      else
	cout << "Unknown how to pass matched RSEG " << match 
	     << " to RTRA \n";
    }      

  // now save RTRA
  for(vector<Rc99MatchComb>::iterator itMatch = matches.points.begin();
       itMatch != matches.points.end(); ++itMatch )
    {
      itMatch->makeRTRA();
    }

  return 0;

}
