#ifndef _RICH_H_
#define _RICH_H_

#include "arte/arte.hh"
#include "rich/vessel.h"
#include "rich/PhotonDetection.h"
#include "rich/PhiLambda.h"
#include "rich/RICHDAQ.h"
#include "rich/RunUtility.h"

extern "C" {

// -------------------------------------------------------------------------
// --- Functions for RICH event processing
// --- a) richinit_() 
// --- b) richexit_()
// --- c) dric2hitb_();
// --- d) richprint_()
//

  /// Initialization of RICH
  void initrich_();
  /// Exit from RICH
  void exitrich_();
  /// Printout of RICH initialization status
  void printrich_();
  /// RICH event processing, HITB is filled from DRIC
  void dric2hitb_();
  /// Obsolete, calls dric2hitb.
  void hidric_(int n=0);

  /// Get radius for beta=1 particles
  float getRadius(int runno, int verb=0);

  /// Get magnet status
  void RICH_find_magnet();
  /// Get RICH gede
  void RICH_find_gede();


}


#endif
