//-----------------------------------------------------------------------//
//
//  Attributes for stand-alone ring reconstruction
//  Author: Denis Dujmic
//  Created: May-00
//
//  Modifications:
//    29 May, 2000 (DD): RingSearchAttrib::use_underdogs=false
//    May 29, 2000 (DD): RingSearchAttrib::finer_search_step added 
//                      
//-----------------------------------------------------------------------//
#include "rise/RingSearchAttrib.h"

bool  RingSearchTrack::exist=false;
float RingSearchTrack::bx=0;
float RingSearchTrack::by=0;
float RingSearchTrack::phi=0;
float RingSearchTrack::lambda=0;
float RingSearchTrack::ip=0;
ArtePointer<RTRA> RingSearchTrack::rtra=0;
ArtePointer<RSEG> RingSearchTrack::rseg=0;
float RingSearchTrack::max_phi_residual=.001;
float RingSearchTrack::max_lambda_residual=5*RingSearchTrack::max_phi_residual;
float RingSearchTrack::aa=.03*.03;
float RingSearchTrack::bb=.0025*.0025;
float RingSearchTrack::sigma2_rr  = 1.5e-5 * 1.5e-5;
float RingSearchTrack::min_rpnt_z=550;
float RingSearchTrack::max_rpnt_z=1350;

int   RingSearchAttrib::type=RingSearchType::nobg;
bool  RingSearchAttrib::reuse=true;
bool  RingSearchAttrib::bookrseg=true;
bool  RingSearchAttrib::bookhitb=false;
bool  RingSearchAttrib::fillrtra=false;
float RingSearchAttrib::SNcut=3;      
float RingSearchAttrib::Scut=10.;
int   RingSearchAttrib::occupancyCut=20000;
int   RingSearchAttrib::peakCut=5;        
float RingSearchAttrib::minSearchRadius=.03;
float RingSearchAttrib::maxSearchRadius=.0526;
float RingSearchAttrib::searchStep=-1;
int   RingSearchAttrib::peakThreshold=5;
bool  RingSearchAttrib::renorm=false;
bool  RingSearchAttrib::id=true;
bool  RingSearchAttrib::use_simple_R2P2=false;
bool  RingSearchAttrib::use_seed_phi=false;
bool  RingSearchAttrib::use_seed_lambda=false;
bool  RingSearchAttrib::choose_best_ring=true;
int   RingSearchAttrib::seed_type=RingSearchType::rtra_seed;
bool  RingSearchAttrib::use_underdogs=false;
bool  RingSearchAttrib::finer_search_step=true;
