#ifndef _riter_fill_h_
#define _riter_fill_h_
#include <riter/RITERMain.hh>

/// main class to be called from ARTE environment
class Riter : public RITERMain {
public:
  /// resets tracks
  int  ResetTracks();

  /// adds a photon to a photons vector  from ARTE bank HITB called by Fillfotons_HITB()
  int    AddPhoton(ArtePointer<HITB> hitb,int &nhitb);

  /// adds a track to a track vector with a refernce to  ARTE track RTRA
  int    AddTrack(ArtePointer<RTRA> rtra,
	     	  RITERVec &dir,
                  float err,
		  RITERVec &point,
		  float p);

  int    Iterate(int mode=0);


  /// adds a track to a track vector from ARTE bank RPNT : called by  Filltracks_RPNT()
  int    Filltracks_RPNT2(ArtePointer<RTRA> rtra,int &itra);
  /// adds a track to a track vector from ARTE bank RPNT 
  int    Filltracks_RPNT();

  /// adds a track to a track vector from ARTE bank RPNT : called by  Filltracks_MTRA()
  int    Filltracks_MIMP(ArtePointer<MTRA> mtra,int &nhitb);
  /// adds a track to a track vector from ARTE bank RPNT 
  int    Filltracks_MTRA();

  /// adds a track to a track vector from ARTE bank RSEG
  int    Filltracks_RSEG();
  int    Filltracks_MIMPdenis(int &nhitb);

  int    Fillfotons_HITB();
  /// fills ARTE bank RTRA with the resulting normalized likelihoods
  void   FillRTRA(int mode);  
  /// fills ARTE bank RSEG with the resulting normalized likelihoods and creates links to rtra
  void   FillRSEG(int mode);  
 
  // *********************** public members 
public:
  int  CherenkovAngle(int nbins, float min, float max, float *xarray);
  /// routine called each event from rcevnt() or similar
  int  Riter_evnt();
  /// constructor
  Riter():RITERMain(){};
  /// destructor
  ~Riter(){ 
#ifdef RITER_DEBUG
    cout<< "deliting Class::Riter \n";
#endif
  };
};

/// global pointer to the Riter class
extern Riter *reco_Riter;

// ---------------------------------------------------------------------

#endif 












