#ifndef _riter_sphericalmirror_h_
#define _riter_sphericalmirror_h_

#include <riter/RITER.hh>

/// class with information about spherical mirrors
class RITERSphericalmirror {
protected:  
  /// spherical mirrors CoC(up)
  RITERVec rc_mu;
  /// spherical mirrors CoC(down)
  RITERVec rc_md;    
  /// spherical mirrors CoC(nonsegmented)
  RITERVec rcmi[2];        
  /// spherical mirrors centers
  RITERVec sf_cen[80];     
  /// curvature radius for upper and lower non segmented mirrors
  float r_mi[2];
  /// corrections of positions for spherical mirrors- x direction
  float dx_sph[80];
  /// corrections of positions for spherical mirrors- y direction
  float dy_sph[80];

public:

  /// return center of curvature of nonsegmented Sph. mirrors
  RITERVec CoC(int id){ return rcmi[id]; };
  /// return  curvature radius  of nonsegmented Sph. mirrors
  float   Radius(int id){ return r_mi[id]; };
  /// returns Which spherical mirror is hit
  int Which_SFM(RITERVec &r);
  /// print content of the class
  int PrintSphericalmirror();
  /// constructor
  RITERSphericalmirror();
  /// destructor
  ~RITERSphericalmirror(){};
};

#endif

