// *****************************************************************************
//
// source:    L3_Defines.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************
#ifndef _L3_DEFINES_HH_
#define _L3_DEFINES_HH_

#ifndef L3_EXTERNAL
//***** Author specific stuff************************************
//#define ULLI
//#define STEFAN
//***************************************************************
//***** Framework ***********************************************
#ifdef USE_ARTE
#define L3_ARTE_FRAME
//***************************************************************
//***** Arte conventions ****************************************
//#define L3_ARTE2
#define L3_ARTE3
//***** Geometry ************************************************
//  For ARTE-01-08-r1:
//  Rotate back boundaries and stereo-angle 
//  with rotation matrix to standard SVD-Geo Definition
#define  L3_SVD_ROTATE_GEO
//***************************************************************
#else
#define L3_SLP_FRAME
//***************************************************************
#endif
//***** Operation Mode ******************************************
//#define L3_ONLINE_MODE
#define L3_OFFLINE_MODE
//***************************************************************
//***** Switch off Rhp and/or Paw********************************
//#define L3_NO_RHP
//#define L3_NO_PAW
//***************************************************************
//***** Debugging Stuff *****************************************
#define L3_PRINT_EVENT_SUMMARY
#define L3_VERBOSE
//#define L3_DEBUG
//#define L3_DEBUG_SILICON
//#define L3_DEBUG_TRACK
//***************************************************************
#endif

#endif
