#ifndef _L3_IMPACT_HH_
#define _L3_IMPACT_HH_
// *****************************************************************************
//
// source:    L3_Impact.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************
#include "L3_ImpactBase.hh"
#include "L3_Track.hh"
#include "L3_Target.hh"
#include "L3_Vertex.hh"

class L3_Impact : public L3_ImpactBase {
public:
  inline L3_Impact();
  inline L3_Impact(const L3_Impact& a){ *this=a; }
  inline L3_Impact(float mag,float variance,float sign=1.0);
  inline L3_Impact(L3_Track& t, const L3_Vertex& v );
  inline L3_Impact(L3_Vertex& v,L3_Track& t );
  inline L3_Impact(L3_Track& t, const L3_Target& targ );
  inline L3_Impact(const L3_Target& targ, L3_Track& t );
  inline L3_Impact(L3_Track& t, L3_Track& s );
  inline L3_Impact(L3_Track& t, const L3_Vertex& v,const L3_Target *p);
  inline L3_Impact& operator=(const L3_Impact&);
private:
  void calc(L3_Track& tra01,L3_Track& tra02);
  void calc(L3_Track& track,const L3_Vertex& vtx);
  void calc(L3_Track& track,const L3_Target& targ);
  void calc(L3_Track& t, const L3_Vertex& v,const L3_Target *p);
};

#include "L3_Impact.icc"
#endif
